﻿package
{
	import org.rest.Request;
	import org.rest.ResultEvent;
	import org.rest.StateEvent;
	import org.toodledo.User;
	import org.toodledo.Task;
	import org.toodledo.Folder;
	import org.toodledo.Parser;
	import flash.display.*;
	import fl.controls.DataGrid;  
	import fl.data.DataProvider; 
	import fl.controls.ComboBox; 
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.MouseEvent;
	
	public class Main extends MovieClip
	{
		private var _user:User;
		
		private var _id:String = "";
		private var _pass:String = "";
		
		private var _client:Request;
		private var _folders:Array;
		private var _tasks:Array;
		
		var taskFirst:Boolean = false;
		var descFirst:Boolean = false;
		
		public function Main()
		{
			task.tabIndex = 1;
			desc.tabIndex = 2;
			task.addEventListener(FocusEvent.FOCUS_IN,active);
			desc.addEventListener(FocusEvent.FOCUS_IN,active);
			_client = Request.getInstance();
			_client.addEventListener(ResultEvent.RESULTS_RECEIVED, processResult);
			this.addEventListener(StateEvent.STATE_CHANGED, changeState);
			
			_user = new User(_id,_pass,_client,this);
			
			if(_user.token.isFresh())
			{
				dispatchEvent(new StateEvent(StateEvent.STATE_CHANGED, "token"));
			}
			else
			{
				trace("fetch new token");
				_client.authenticate(_id);
			}
		}
		
		protected function processResult(evt:ResultEvent):void
		{
			var data:XML = evt.data;
			trace(data.name().localName);
			// get our results..
			if(data.name().localName == "token")
			{
				 _user.setToken(data);
			}
			else if(data.name().localName == "tasks")
			{
				 _tasks = Parser.parseTasks(data);
				 dispatchEvent(new StateEvent(StateEvent.STATE_CHANGED, data.name().localName));
			}
			else if(data.name().localName == "folders")
			{
				 _folders = Parser.parseFolders(data);
				 dispatchEvent(new StateEvent(StateEvent.STATE_CHANGED, data.name().localName));
			}
		}
		
		private function fillTable():void
		{
			var myDP:DataProvider = new DataProvider();  
			for each (var t:Task in _tasks) 
			{
				if(t.isNotcomp())
				{	
					var folder:String ="";
					for each (var f:Folder in _folders) 
					{
						if(f.getId() == t.getFolder())
						{
							folder = f.getSName();
						}
					}
					var tex:String = t.getPriority()>2?"!":"";
					myDP.addItem({Title:t.getTitle(), Prio:tex, Folder:folder/* Datum und Importante*/});
				} 
			}
			
			//sort myDP by prio
			
			var TaskTable:DataGrid = new DataGrid();  
			TaskTable.addColumn("Prio"); 
			TaskTable.addColumn("Title");   
			TaskTable.addColumn("Folder"); 
			TaskTable.dataProvider = myDP;  
			TaskTable.width = 580; 
			TaskTable.height = 280;
			TaskTable.move(10, 110);  
			addChild(TaskTable); 
			
			/*combo box*/
			var mylDP:DataProvider = new DataProvider();  
			for each (var f:Folder in _folders) 
			{
				mylDP.addItem({label:f.getSName(), data:f.getId()});
			}
			
			var folderBox:ComboBox = new ComboBox(); 
			//folderBox.dropdownWidth = 210; 
			folderBox.width = 200;  
			folderBox.move(10, 80);
			folderBox.dataProvider = new DataProvider(mylDP); 
			//folderBox.addEventListener(Event.CHANGE, changeHandler);
			addChild(folderBox);
		}
		
		protected function changeState(evt:StateEvent):void
		{
			var data:String = evt.data;
			
			trace("STATE -- > "+data);
			if(data == "token")
			{
				 _client.getFolder(_user.Key);
			}
			else if(data == "folders")
			{
				 _client.getTasks(_user.Key);
			}
			else if(data == "tasks")
			{
				 trace("SHOW ALL OF THEM IN TABLE");
				 submit.buttonMode = true;
				 submit.addEventListener(MouseEvent.MOUSE_UP,addTask);
				 fillTable();
				 loada.visible = false;
			}
		}
		
		public function addTask(e:MouseEvent):void
		{
			var task:Task = new Task();
			task.setTitle("testooo");
			//task.getFolder() };
			//if (todo.hasPriority()) { variables.priority = todo.getPriority() };
			task.setNote("bla bla bla bla bal");
			_client.addTask(_user.Key,task);
		}

		public function active(e:Event):void
		{
			if(!taskFirst)
			{
				e.target.text = "";
				e.target.textColor = 0x000000;
			}
				
			if(!descFirst)
			{
				e.target.text = "";
				e.target.textColor = 0x000000;
			}
				
			if(e.target.name == "task")
				taskFirst = true;
			
			if(e.target.name == "desc")
				descFirst = true;
		}
	}
}