package org.loststone.toodledo.request {
import java.io.IOException;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.methods.GetMethod;
import org.loststone.toodledo.response.Response;

public abstract class Request {
	private var authToken:String= null;
	// url to the service
	protected var url:String= null; 
	protected var xmlResponse:String= null; 
	
	/**
	 * Should execute the exec method and give back an appropiate response type. 
	 * @return
	 */
	public abstract function getResponse():Response ;
	
	/**
	 * This methods executes the HTTP GET of the URL and stores the result
	 * in String format in the xmlResponse field.
	 */
	public function exec():void {
		var client:HttpClient= new HttpClient();
		var method:HttpMethod= new GetMethod(this.url);
		try {
			client.executeMethod(method);
			this.xmlResponse = method.getResponseBodyAsString();
		} catch (var e:HttpException) {
			e.printStackTrace();
		} catch (var e:IOException) {
			e.printStackTrace();
		} finally {
			method.releaseConnection();
		}
	}
	
	public function getAuthToken():String {
		return authToken;
	}
	
	public function setAuthToken(authToken:String):void {
		this.authToken = authToken;
	}
	
}
}