﻿package org.rest
{
	import flash.net.URLRequestMethod;
    import flash.net.URLVariables;

	import flash.events.Event;
    import flash.net.URLLoader;
    import flash.net.URLRequest;
    import flash.net.URLLoaderDataFormat;
    import flash.events.IOErrorEvent;
    import flash.events.SecurityErrorEvent;
	import flash.events.EventDispatcher;
	
	import org.toodledo.Task;

	public class Request extends EventDispatcher
	{
		private static var _instance:Request;
		public static function getInstance():Request
        {
            if (_instance == null)
                _instance = new Request();
            return _instance;
        }

		public function Request(){}
		
		public function authenticate(userid:String):void
		{
			var variables:URLVariables = new URLVariables();
			variables.userid = userid;
			variables.method="getToken";
			
			runRequest(variables);
		}
		
		public function getTasks(key:String):void
		{
			var variables:URLVariables = new URLVariables();
			variables.key = key;
			variables.method="getTasks";
			
			runRequest(variables);
		}
		
		public function getFolder(key:String):void
		{
			var variables:URLVariables = new URLVariables();
			variables.key = key;
			variables.method="getFolders";
			
			runRequest(variables);
		}
		
		public function addTask(key:String,task:Task):void
		{
			var variables:URLVariables = new URLVariables();
			
			if (task.hasTitle()){ variables.title = task.getTitle(); }
			if (task.hasFolder()) { variables.folder = task.getFolder(); }
			if (task.hasPriority()) { variables.priority = task.getPriority(); }
			if (task.hasNote()) { variables.note = task.getNote(); }		
			
			variables.key = key;
			variables.method="addTask";
			
			runRequest(variables);
		}
		
		public function runRequest(variables:URLVariables):void
		{
			// we are still sending GET variables along..
			var request:URLRequest = new URLRequest("http://api.toodledo.com/api.php");
			var loader:URLLoader = new URLLoader();
			// "ioError"
			loader.addEventListener(IOErrorEvent.IO_ERROR, handleIOError);
			// "securityError"
			loader.addEventListener(SecurityErrorEvent.SECURITY_ERROR , handleSecurityError);

			loader.dataFormat = URLLoaderDataFormat.TEXT;
			request.method = URLRequestMethod.POST;
			// assign the data to be sent by POST
			request.data = variables;
			loader.addEventListener(Event.COMPLETE, handleResults);
			loader.load(request);
		}
		
		function handleResults(evt:Event):void
		{
			var response:String = evt.target.data as String;
			var xmlData:XML;
			
			try
		    {
				xmlData = new XML(response);
				dispatchEvent(new ResultEvent(ResultEvent.RESULTS_RECEIVED, xmlData));
         	}
   			catch(error:TypeError)
         	{
            	trace("the response data was not in valid XML format");
          	}
      	}

		protected function handleIOError(evt:IOErrorEvent):void
		{
			trace("handleIOError(" + evt.toString());
		}
		  
		protected function handleSecurityError(evt:SecurityErrorEvent):void
		{
			trace("handleSecurityError("+evt.toString());         
		}
	}
}