﻿package org.toodledo {

/**
 * This class maps all the components of a toodledo task. For more info
 * go to http://www.toodledo.com/info/api_doc.php
 * @author lant
 *
 */
public class Task {
	var _title:String;
	var _tag:String; 
	var _folder:int; // id of the folder, 0 means no folder.
	var _context:int; // 0 no context
	var _goal:int; // 0 no goal
	var _priority:int;
	var _repeat:int;
	var _rep_advanced:String; 
	var _status:int;
	var _parent:int; // 0 if none
	var _shorter:int; 
	var _length:int; 
	var _longer:int;
	var _before:Date;
	var _after:Date; 
	var _startbefore:Date; 
	var _startafter:Date;
	var _modbefore:Date;
	var _modafter:Date; 
	var _compbefore:Date;
	var _compafter:Date; 
	var _notcomp:Boolean;
	var _star:Boolean; 
	var _id:int; 
	var _start:int; 
	var _end:int;
	var _note:String; 
	private var _hasEnd:Boolean= false;
	private var _hasStart:Boolean= false;
	private var _hasId:Boolean= false;
	private var _hasStar:Boolean= false;
	private var _hasComp:Boolean= false;
	private var _hasCompafter:Boolean= false;
	private var _hasCompbefore:Boolean= false;
	private var _hasModbefore:Boolean= false;
	private var _hasModafter:Boolean= false;
	private var _hasStartafter:Boolean= false;
	private var _hasStartbefore:Boolean= false;
	private var _hasAfter:Boolean= false;
	private var _hasBefore:Boolean= false;
	private var _hasLonger:Boolean= false;
	private var _hasShorter:Boolean= false;
	private var _hasParent:Boolean= false;
	private var _hasStatus:Boolean= false;
	private var _hasRepeat:Boolean= false;
	private var _hasPriority:Boolean= false;
	private var _hasGoal:Boolean= false;
	private var _hasContext:Boolean= false;
	private var _hasFolder:Boolean= false;
	private var _hasTag:Boolean= false;
	private var _hasTitle:Boolean= false;
	private var _hasRepAdvanced:Boolean= false;
	private var _hasLength:Boolean= false; 
	private var _hasNote:Boolean= false; 
	
	public function Todo() {}

	
	/**
	 * @return the title
	 */
	public function getTitle():String {
		return this._title;
	}
	
	/**
	 * Sets the title for the task.
	 * @param title the title to set. If the title is longer than 255 charts it will be cropped.
	 */
	public function setTitle(title:String):void {
		if (title.length > 254)
			this._title = title.substring(0,254);
		else
			this._title = title;
		
		this._hasTitle = true;
	}
	
	/**
	 * @var _the tag
	 */
	public function getTag():String {
		return this._tag;
	}
	
	/**
	 * Set the rep_advanced.
	 */
	public function getRepAdvanced():String {
		return this._rep_advanced;
	}
	
	/**
	 * Get the rep_advanced.
	 */
	public function setRepAdvanced(repAdv:String):void {
		this._rep_advanced = repAdv; 
		this._hasRepAdvanced = true;
	}
	
	public function setNote(note:String):void {
		this._note = note; 
		this._hasNote = true;
	}
	
	public function getNote():String {
		return this._note;
	}
	
	public function getLength():int {
		return this._length;
	}
	
	public function setLength(length:int):void {
		this._length = length;
		this._hasLength = true;
	}
	
	/**
	 * @param tag the tag to set
	 */
	public function setTag(tag:String):void {
		this._tag = tag;
		this._hasTag = true;
	}
	
	/**
	 * @return the folder
	 */
	public function getFolder():int {
		return _folder;
	}
	
	/**
	 * @param folder the folder to set
	 */
	public function setFolder(folder:int):void {
		this._folder = folder;
		this._hasFolder = true;
	}
	
	/**
	 * @return the context
	 */
	public function getContext():int {
		return _context;
	}
	
	/**
	 * @param context the context to set
	 */
	public function setContext(context:int):void {
		this._context = context;
		this._hasContext = true;
	}
	
	/**
	 * @return the goal
	 */
	public function getGoal():int {
		return _goal;
	}
	
	/**
	 * @param goal the goal to set
	 */
	public function setGoal(goal:int):void {
		this._goal = goal;
		this._hasGoal = true;
	}
	
	/**
	 * @return the int
	 */
	public function getPriority():int {
		return _priority;
	}
	
	/**
	 * @param priority the priority to set
	 */
	public function setPriority(priority:int):void {
		this._priority = priority;
		this._hasPriority = true;
	}
	
	/**
	 * @return _the repeat
	 */
	public function getRepeat():int {
		return _repeat;
	}
	
	/**
	 * @param repeat the repeat to set
	 */
	public function setRepeat(repeat:int):void {
		this._repeat = repeat;
		this._hasRepeat = true; 
	}
	
	/**
	 * @return _the status
	 */
	public function getStatus():int {
		return _status;
	}
	
	/**
	 * @param status the status to set
	 */
	public function setStatus(status:int):void {
		this._status = status;
		this._hasStatus = true;
	}
	
	/**
	 * @return _the parent
	 */
	public function getParent():int {
		return _parent;
	}
	
	/**
	 * @param parent the parent to set
	 */
	public function setParent(parent:int):void {
		this._parent = parent;
		this._hasParent = true;
	}
	
	/**
	 * @return _the shorter
	 */
	public function getShorter():int {
		return _shorter;
	}
	
	/**
	 * @param shorter the shorter to set
	 */
	public function setShorter(shorter:int):void {
		this._shorter = shorter;
		this._hasShorter = true; 
	}

	/**
	 * @return _the longer
	 */
	public function getLonger():int {
		return _longer;
	}
	
	/**
	 * @param longer the longer to set
	 */
	public function setLonger(longer:int):void {
		this._longer = longer;
		this._hasLonger = true;
	}
	
	/**
	 * @return _the before
	 */
	public function getBefore():Date {
		return _before;
	}
	
	/**
	 * @param before the before to set
	 */
	public function setBefore(before:Date):void {
		this._before = before;
		this._hasBefore = true;
	}
	
	/**
	 * @return _the after
	 */
	public function getAfter():Date {
		return _after;
	}
	
	/**
	 * @param after the after to set
	 */
	public function setAfter(after:Date):void {
		this._after = after;
		this._hasAfter = true;
	}
	
	/**
	 * @return _the startbefore
	 */
	public function getStartbefore():Date {
		return _startbefore;
	}
	
	/**
	 * @param startbefore the startbefore to set
	 */
	public function setStartbefore(startbefore:Date):void {
		this._startbefore = startbefore;
		this._hasStartbefore = true;
	}
	
	/**
	 * @return _the startafter
	 */
	public function getStartafter():Date {
		return _startafter;
	}
	
	
	/**
	 * @param startafter the startafter to set
	 */
	public function setStartafter(startafter:Date):void {
		this._startafter = startafter;
		this._hasStartafter = true;
	}
	
	/**
	 * @return _the modbefore
	 */
	public function getModbefore():Date {
		return _modbefore;
	}
	
	/**
	 * @param modbefore the modbefore to set
	 */
	public function setModbefore(modbefore:Date):void {
		this._modbefore = modbefore;
		this._hasModbefore = true;
	}
	
	/**
	 * @return _the modafter
	 */
	public function getModafter():Date {
		return _modafter;
	}
	
	/**
	 * @param modafter the modafter to set
	 */
	public function setModafter(modafter:Date):void {
		this._modafter = modafter;
		this._hasModafter = true;
	}
	
	/**
	 * @return _the compbefore
	 */
	public function getCompbefore():Date {
		return _compbefore;
	}
	
	/**
	 * @param compbefore the compbefore to set
	 */
	public function setCompbefore(compbefore:Date):void {
		this._compbefore = compbefore;
		this._hasCompbefore = true;
	}
	
	/**
	 * @return _the compafter
	 */
	public function getCompafter():Date {
		return _compafter;
	}
	
	/**
	 * @param compafter the compafter to set
	 */
	public function setCompafter(compafter:Date):void {
		this._compafter = compafter;
		this._hasCompafter = true;
	}
	
	/**
	 * @return _the notcomp
	 */
	public function isNotcomp():Boolean {
		return _notcomp;
	}
	
	/**
	 * @param notcomp the notcomp to set
	 */
	public function setNotcomp(notcomp:Boolean):void {
		this._notcomp = notcomp;
		this._hasComp = true;
	}

	/**
	 * @return _the star
	 */
	public function isStar():Boolean {
		return _star;
	}
	
	/**
	 * @param star the star to set
	 */
	public function setStar(star:Boolean):void {
		this._star = star;
		this._hasStar = true;
	}
	
	/**
	 * @return _the id
	 */
	public function getId():int {
		return _id;
	}
	
	/**
	 * @param id the id to set
	 */
	public function setId(id:int):void {
		this._id = id;
		this._hasId = true;
	}
	
	/**
	 * @return _the start
	 */
	public function getStart():int {
		return _start;
	}
	
	/**
	 * @param start the start to set
	 */
	public function setStart(start:int):void {
		this._start = start;
		this._hasStart = true;
	}
	
	/**
	 * @return _the end
	 */
	public function getEnd():int {
		return _end;
	}
	
	/**
	 * @param end the end to set
	 */
	public function setEnd(end:int):void {
		this._end = end;
		this._hasEnd = true;
	}

	/**
	 * @return _the hasEnd
	 */
	public function hasEnd():Boolean {
		return _hasEnd;
	}

	/**
	 * @return _the hasStart
	 */
	public function hasStart():Boolean {
		return _hasStart;
	}

	/**
	 * @return _the hasId
	 */
	public function hasId():Boolean {
		return _hasId;
	}

	/**
	 * @return _the hasStar
	 */
	public function hasStar():Boolean {
		return _hasStar;
	}

	/**
	 * @return _the hasComp
	 */
	public function hasComp():Boolean {
		return _hasComp;
	}

	/**
	 * @return _the hasCompafter
	 */
	public function isHasCompafter():Boolean {
		return _hasCompafter;
	}

	/**
	 * @return _the hasCompbefore
	 */
	public function hasCompbefore():Boolean {
		return _hasCompbefore;
	}

	/**
	 * @return _the hasModbefore
	 */
	public function hasModbefore():Boolean {
		return _hasModbefore;
	}

	/**
	 * @return _the hasModafter
	 */
	public function hasModafter():Boolean {
		return _hasModafter;
	}

	/**
	 * @return _the hasStartafter
	 */
	public function hasStartafter():Boolean {
		return _hasStartafter;
	}

	/**
	 * @return _the hasStartbefore
	 */
	public function hasStartbefore():Boolean {
		return _hasStartbefore;
	}

	/**
	 * @return _the hasAfter
	 */
	public function hasAfter():Boolean {
		return _hasAfter;
	}

	/**
	 * @return _the hasBefore
	 */
	public function hasBefore():Boolean {
		return _hasBefore;
	}

	/**
	 * @return _the hasLonger
	 */
	public function hasLonger():Boolean {
		return _hasLonger;
	}

	/**
	 * @return _the hasShorter
	 */
	public function hasShorter():Boolean {
		return _hasShorter;
	}

	/**
	 * @return _the hasParent
	 */
	public function hasParent():Boolean {
		return _hasParent;
	}

	/**
	 * @return _the hasStatus
	 */
	public function hasStatus():Boolean {
		return _hasStatus;
	}

	/**
	 * @return _the hasRepeat
	 */
	public function hasRepeat():Boolean {
		return _hasRepeat;
	}

	/**
	 * @return _the hasPriorit
	 */
	public function hasPriority():Boolean {
		return _hasPriority;
	}

	/**
	 * @return _the hasGoal
	 */
	public function hasGoal():Boolean {
		return _hasGoal;
	}

	/**
	 * @return _the hasContext
	 */
	public function hasContext():Boolean {
		return _hasContext;
	}

	/**
	 * @return _the hasFolder
	 */
	public function hasFolder():Boolean {
		return _hasFolder;
	}

	/**
	 * @return _the hasTag
	 */
	public function hasTag():Boolean {
		return _hasTag;
	}

	/**
	 * @return _the hasTitle
	 */
	public function hasTitle():Boolean {
		return _hasTitle;
	} 
	
	public function hasRepAdvanced():Boolean {
		return this._hasRepAdvanced;
	}
	
	public function hasLength():Boolean {
		return this._hasLength;
	}
	
	public function hasNote():Boolean {
		return this._hasNote;
	}
}
}